#ifndef LIBRARY_H_
#define LIBRARY_H_

#include"Document.h"
#include"Book.h"
#include"ConferencePaper.h"
#include"JournalArticle.h"

#include<iostream>
#include<vector>
#include<algorithm>
#include<fstream>
#include<string>

class Library{
public:
    Library(std::string filename){
        readFromFile(filename);
    }
    ~Library();
    
    void printByTime();
    void printByAuthor();
    
    void queryByAuthor(std::string a);
    void queryByTime(int begin, int end);
    
    void readFromFile(std::string filename){
        std::ifstream file(filename);
        std::string line;
        while (!file.eof()){
            std::getline(file, line);
            std::string::size_type begin = line.find_first_of(": ", 0);
            std::string type = line.substr(0, begin);
            std::string content = line.substr(begin + 2, line.length() - begin - 2);
            if (type == "CP"){
                Document* cp = new ConferencePaper(content);
                doc_list.push_back(cp);
            }
            else if (type == "JA"){
                Document* ja = new JournalArticle(content);
                doc_list.push_back(ja);
            }
            else if (type == "Bo"){
                Document* bo = new Book(content);
                doc_list.push_back(bo);
            }
        }
        file.close();
    }
    
private:
    std::vector<Document*> doc_list;
};

#endif
